
#define F_CPU 16000000

#include <avr/io.h>
#include <util/delay.h>

int player = 0;

void func(void) {

	int i;

	//setare pini pentru led-uri si butoane

	for(i = 0; i < 8; i++ ){
		DDRA |= (1 << i);
		PORTA &= ~(1 << i);
		
		DDRC &= ~(1 << i);
		PORTC |= (1 << i);
	}
	
	DDRB |= (1 << PB0);
	PORTB &= ~(1 << PB0);
	
	DDRB &= ~(1 << PB1);
	PORTB |= (1 << PB1);
	
	for(i = 2; i < 8; i++ ){
		DDRB |= (1 << i);
		PORTB &= ~(1 << i);
	}
	
	for(i = 0; i < 7; i++ ){
		DDRD |= (1 << i);
		PORTD &= ~(1 << i);
	}
	
	DDRD &= ~(1 << PD7);
	PORTD |= (1 << PD7);
	
	int v[9];
	
	for(i = 0; i < 9; i++)
		v[i] = 0;
	
	while(1){
		
		if(player == 0){
			//daca butonul e apasat
			if ((PINB & (1 << PB1)) == 0) {
				if(v[8]==0) {
					v[8]=1;
					//aprinde led
					PORTB |= (1 << PB0);
				}
				
				for(i = 0; i < 8; i++)
					if ((PINC & (1 << i)) == 0)
						if(v[i]==0) {
							v[i]=1;
							//aprinde led
							PORTA |= (1 << i);
						}
			}
			
			//sa ramana aprins cat timp v[8] e 0
			if(v[8]==0)
				PORTB &= ~(1 << PB0);
			
			//sa ramana stins cat timp v[8] e 1
			if(v[8]==1)
				PORTB |= (1 << PB0);
				
			for(i = 0; i < 8; i++) {
				//sa ramana aprins cat timp v[i] e 0
				if(v[i]==0)
					PORTA &= ~(1 << i);
				
				//sa ramana stins cat timp v[i] e 1
				if(v[i]==1)
					PORTA |= (1 << i);
			}
			
		} else {		
			//daca butonul e apasat
			if ((PINB & (1 << PB1)) == 0) {
				if(v[8]==0) {
					v[8]=1;
					//aprinde led
					PORTD |= (1 << PD2);
				}
			}
			for(i = 0; i < 5; i++){
				if ((PINC & (1 << i)) == 0)
					if(v[i]==0) {
						v[i]=1;
						//aprinde led
						PORTB |= (1 << (i + 2));
					}
			}
			
			if ((PINC & (1 << PC6)) == 0)
				if(v[6]==0) {
					v[i]=1;
					PORTD |= (1 << PD0);
				}
			
			if ((PINC & (1 << PC7)) == 0)
				if(v[7]==0) {
					v[i]=1;
					PORTD |= (1 << PD1);
				}
			//sa ramana aprins cat timp v[8] e 0
			if(v[8]==0)
				PORTB &= ~(1 << PB0);
			
			//sa ramana stins cat timp v[8] e 1
			if(v[8]==1)
				PORTB |= (1 << PB0);
				
			//sa ramana aprins cat timp v[6] e 0
			if(v[6]==0)
				PORTD &= ~(1 << PD0);
				
			//sa ramana stins cat timp v[6] e 1
			if(v[6]==1)
				PORTD |= (1 << PD0);
			
			//sa ramana aprins cat timp v[7] e 0
			if(v[7]==0)
				PORTD &= ~(1 << PD1);
				
			//sa ramana stins cat timp v[7] e 1
			if(v[7]==1)
				PORTD |= (1 << PD1);
			
			for(i = 0; i < 5; i++){
				if(v[i]==0) 
					PORTB &= ~(1 << (i + 2));
				if(v[i]==1)
					PORTB |= ~(1 << (i + 2));
			}
		}	
		if(player == 0 )
			player = 1;
		else
			player = 0;
	}	
}


int main(void) {
	func();

	return 0;
}